git@vger.kernel.org mailing list mirror (one of many)
 help / color / mirror / code / Atom feed
From: David Aguilar <davvid@gmail.com>
To: git@vger.kernel.org
Subject: [RFC PATCH 1/2] Makefile: add check-headers target
Date: Sat,  6 Sep 2014 12:20:10 -0700	[thread overview]
Message-ID: <1410031211-14599-1-git-send-email-davvid@gmail.com> (raw)

This allows us to ensure that each header can be included
individually without needing to include other headers first.

Signed-off-by: David Aguilar <davvid@gmail.com>
---
This patch demonstrates how to verify PATCH 2/2.

 Makefile         |  6 ++++++
 check-headers.sh | 26 ++++++++++++++++++++++++++
 2 files changed, 32 insertions(+)
 create mode 100755 check-headers.sh

diff --git a/Makefile b/Makefile
index 30cc622..bc54024 100644
--- a/Makefile
+++ b/Makefile
@@ -2591,6 +2591,12 @@ check-docs::
 check-builtins::
 	./check-builtins.sh
 
+### Make sure headers include their dependencies
+#
+check-headers::
+	./check-headers.sh $(CC) $(ALL_CFLAGS)
+
+
 ### Test suite coverage testing
 #
 .PHONY: coverage coverage-clean coverage-compile coverage-test coverage-report
diff --git a/check-headers.sh b/check-headers.sh
new file mode 100755
index 0000000..bf85c41
--- /dev/null
+++ b/check-headers.sh
@@ -0,0 +1,26 @@
+#!/bin/sh
+
+exit_code=0
+
+maybe_exit () {
+	status="$1"
+	if test "$status" != 0
+	then
+		exit_code="$status"
+		if test -n "$CHECK_HEADERS_STOP"
+		then
+			exit "$status"
+		fi
+	fi
+}
+
+git ls-files *.h |
+while read header
+do
+	echo "HEADER $header" &&
+	"$@" -Wno-unused -x c -c -o "$header".bin - <"$header" &&
+	rm "$header".bin ||
+	maybe_exit $?
+done
+
+exit $exit_code
-- 
2.1.0.62.g7dc6c49

             reply	other threads:[~2014-09-06 19:20 UTC|newest]

Thread overview: 10+ messages / expand[flat|nested]  mbox.gz  Atom feed  top
2014-09-06 19:20 David Aguilar [this message]
2014-09-06 19:20 ` [RFC PATCH 2/2] headers: include dependent headers David Aguilar
2014-09-06 21:20   ` René Scharfe
2014-09-08 17:50     ` Junio C Hamano
2014-09-09 19:44       ` René Scharfe
2014-09-08 18:05     ` Junio C Hamano
2014-09-06 21:20 ` [RFC PATCH 1/2] Makefile: add check-headers target René Scharfe
2014-09-06 22:57   ` David Aguilar
2014-09-06 23:58     ` Jeff King
2014-09-07  0:24       ` David Aguilar

Reply instructions:

You may reply publicly to this message via plain-text email
using any one of the following methods:

* Save the following mbox file, import it into your mail client,
  and reply-to-all from there: mbox

  Avoid top-posting and favor interleaved quoting:
  https://en.wikipedia.org/wiki/Posting_style#Interleaved_style

  List information: http://vger.kernel.org/majordomo-info.html

* Reply using the --to, --cc, and --in-reply-to
  switches of git-send-email(1):

  git send-email \
    --in-reply-to=1410031211-14599-1-git-send-email-davvid@gmail.com \
    --to=davvid@gmail.com \
    --cc=git@vger.kernel.org \
    /path/to/YOUR_REPLY

  https://kernel.org/pub/software/scm/git/docs/git-send-email.html

* If your mail client supports setting the In-Reply-To header
  via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line before the message body.
Code repositories for project(s) associated with this public inbox

	https://80x24.org/mirrors/git.git

This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox;
as well as URLs for read-only IMAP folder(s) and NNTP newsgroup(s).